#version unofficial megapov 0.5;

#declare test_casiers_inc = off;

#declare T_Corps_Casier = texture {
	pigment { rgb <.85,.8,.7> }
	normal { dents scale 10 }
	finish {
		specular .2 roughness .01
		reflection_min 0
		reflection_max .3
		reflection_falloff 3
	}
}

#declare T_Poignees_Casier = texture {
	pigment { rgb .3 }
	normal { dents scale 5 }
	finish {
		specular .8 roughness .03
		reflection_min 0
		reflection_max .3
	}
}


#declare Tiroir_Casiers = 
union {
	union {
		box {<-390, 0,-200>,<-380,200,200> }
		box {<-400,10,-200>,<-390,190,200> }
		cylinder{<-390, 10,-200>,<-390, 10,200>,10 }
		cylinder{<-390,190,-200>,<-390,190,200>,10 }
		box { <-390,1,-170>, <390,11,170> }
		box { <-390,1,170>, <390,180,180> }
		box { <-390,70,179>, <390,90,187> }
		box { <-390,110,179>, <390,130,187> }
		box { <-390,1,-170>, <390,180,-180> }
		box { <-390,70,-179>, <390,90,-187> }
		box { <-390,110,-179>, <390,130,-187> }
		texture { T_Corps_Casier }
	}
	union {
		difference {
			torus {30,6}
			plane {<0,0,1>,0}
			translate <-400,150,40>
		}
		difference {
			torus {30,6}
			plane {<0,0,-1>,0}
			translate <-400,150,-40>
		}
		cylinder {<-430,150,-40>,<-430,150,40>,6 }
		texture {T_Poignees_Casier}
	}
	difference {
		box { <0,60,-40>, <6,100,40> }
		box { <-.1,65,-35>, <6.1,95,35> }
		translate <-404, 0, 0>
		texture {T_Poignees_Casier}
	}
}

//----------------------------------------------------------------------------

#declare Casiers_1 =
union {
	union{
		box {<-400,866,-200>,<400,890,200> }
		box {<-390,890,-200>,<390,900,200> }
  		cylinder{<-390,890,-200>,<-390,890,200>,10 }
		cylinder{< 390,890,-200>,< 390,890,200>,10 }
		difference {
			box{<-375,0,-198>,<383,866,198> }
			box{<-384,60,-188>,<380,866,188> }
		}
		texture {T_Corps_Casier}
	}

  object{Tiroir_Casiers translate<0, 60,0>}
  object{Tiroir_Casiers translate<0,262,0>}
  object{Tiroir_Casiers translate<-400,464,0>}
  object{Tiroir_Casiers translate<0,666,0>}

  scale <.001, .0012, .001>
  translate -.4*x
}

#declare Casiers_2 =
union {
	union{
		box {<-400,866,-200>,<400,890,200> }
		box {<-390,890,-200>,<390,900,200> }
  		cylinder{<-390,890,-200>,<-390,890,200>,10 }
		cylinder{< 390,890,-200>,< 390,890,200>,10 }
		difference {
			box{<-375,0,-198>,<383,866,198> }
			box{<-384,60,-188>,<380,866,188> }
		}
		texture {T_Corps_Casier}
	}

  object{Tiroir_Casiers translate<0, 60,0>}
  object{Tiroir_Casiers translate<0,262,0>}
  object{Tiroir_Casiers translate<0,464,0>}
  object{Tiroir_Casiers translate<0,666,0>}

  scale <.001, .0012, .001>
  translate -.4*x
}


// hauteur: 1.08
// largeur: 0.40
// profondeur: 0.80

#if (test_casiers_inc)

camera {
	location <-3, 1.2, 1>
	right x*5
	up y*3
	angle 40
	look_at <0,.5,0>
}

light_source { <-15,15,15>, color rgb 1 }

plane { y, 0
	pigment { checker }
}

object {
	Casiers_1
}

object {
	Casiers_2
	translate .41*z
}


#end
