#version unofficial megapov 0.5;

#default { texture { finish { diffuse 1 ambient 0 } } }

#include "colors.inc"
#include "woods.inc"

#declare T_Mur = texture {
	pigment { color rgb <.98,.98,1> }
	//normal { granite .1 scale .005}
	finish { brilliance .3 }
}

#declare T_Plafond = texture {
	pigment {
		granite
		scale .03
		color_map {
			[.08 rgb <.35,.20,.05>]
			[.08 rgb <.98,.98,.90>]
		}
	}
	normal {
		bozo .5 scale .001
		slope_map {
			[.74 <1,0>]
			[.75 <1,-3>]
			[.76 <0,0>]
		}
	}
	finish { brilliance .6 }
}

#declare T_Neon = texture {
	pigment {
		gradient x
		triangle_wave
		pigment_map {
			[0.0 color rgb <.95,.90,.85> ]
			[0.4 gradient z scale <1,1,1.01> color_map {[0.6 rgb <1,1,.90> ][1 rgb <.95,.90,.85>]} ]
		}
	}
	finish { diffuse 0 ambient 1 }
}

#declare T_Montants_Cage = texture {
	pigment { color rgb .9 }
	normal { bozo .3 scale .2 }
	finish { brilliance .8 phong .2 phong_size 20 specular .3 roughness .01 }
}

#declare T_Grille = texture {
	pigment { color rgb .7 }
	finish { brilliance 2
		specular .7 roughness .03
		phong .3 phong_size 50
	}
}

#declare T_Encadrement_Porte = texture {
	pigment { bozo warp { turbulence .2 } scale .3
		color_map {
			[.1 rgb .5]
			[.8 rgb .4]
		}
	}
	normal { bozo .2 scale .5 warp { turbulence .2 } }
	finish { brilliance 2 specular .4 roughness .1 diffuse .8 }
}

#declare T_Porte = texture {
	pigment {
		wrinkles
		warp { turbulence .1 octaves 3 } scale .2
		color_map {
			[ .1 color rgb .5 ]
			[ .5 color rgb .4 ]
			[ .8 color rgb <.5, .3, .1> ]
		} 
	}
	normal { wrinkles .2 warp { turbulence .1 octaves 3 } scale .5 }
	finish { brilliance 2 specular .4 roughness .1 diffuse .8 }
}

#declare T_Carrelage1 = texture {
	pigment { color rgb 1 }
	normal {
		average
		normal_map {
			[1 bozo .1 scale .1 turbulence .1 octaves 3]
			[1 dents .5 scale .05 ]
		}
	}
	finish {
		brilliance .6
		reflection_min 0
		reflection_max .2
		reflection_falloff 2
		specular .2 roughness .01
		phong .1 phong_size 5
	}
}

#declare T_Carrelage2 = texture {
	pigment { color rgb <1,.9,.8> }
	normal {
		average
		normal_map {
			[1 bozo .1 scale .1 turbulence .1 octaves 3]
			[1 dents .5 scale .05 ]
		}
	}
	finish {
		brilliance .6
	}
}


#declare T_Carrelage = texture {
	wrinkles
	turbulence .4 octaves 3
	scale .5
	texture_map {
		[0.2 T_Carrelage1 ]
		[0.8 T_Carrelage2 ]
	}
}

#declare T_Plastique_Noir = texture {
	pigment { color rgb .2 }
	finish { brilliance .6
		phong .7 phong_size 10
	}
}

#declare T_Plastique_Beige= texture {
	pigment { color rgb <1, .98, .95> }
	finish { brilliance 1.2 diffuse 1.6
		phong .7 phong_size 10
	}
}

#declare T_Paille = texture {
	pigment {
		spotted
		turbulence .4 octaves 2
		scale <.05,.0005,.05>
		color_map {
			[.2 color rgb<1,.9,.3>]
			[.5 color rgb<.9,.7,.4>]
			[.8 color rgb<.9,.5,.1>]
		}
	}
}

